]> git.sesse.net Git - backup.sh/blob - backup.sh
This comment does not really make any sense.
[backup.sh] / backup.sh
1 #!/bin/bash
2 # backup.sh
3
4 # Backup up Unix-like computers
5
6 # itk@samfundet.no
7 #
8 # This script was first checked into RCS in 2000, and has since backed up a few
9 # servers almost every day, whenever not broken.
10
11 # It's a bit peculiar, but quite effective. The following is worth keeping in
12 # mind when hacking:
13 #
14 # Because of the way we run this script from cron, informational logging goes
15 # to stderr and warnings and errors to stdout. This way, we get mail whenever
16 # stuff fails, and other output is redirected to the log file.
17
18 # The script is halfway Norwegian and halfway English. Newer modifications are
19 # in English, we should probably stick to that.
20
21 # The computer to backup.
22 computer=$1
23
24 # Configuration
25 LOCKFILE=/home/backup/backuprun.lockfile.$computer
26 confdir=/home/backup/conf/              # Configuration files
27 storagedir=/backup                      # Where we keep backups
28 maxnumfull=3                            # Number of full backups
29 daysbetweenfull=30                      # Days between full backups
30 daysbetweenfullforfixed=32              # Days between full backups for machines with fixed
31                                         # full-backup date (in case the fixed day gets missed)
32 DAY_OF_MONTH=`date "+%d" | sed s/^0//`  # from 1 to 31
33 DATE=`date "+%Y%m%d%H%M"`               #format: touch
34 DATEs=`date "+%Y-%m-%d %H:%M"`          #format: tar
35
36 # Exclude-pattern
37 exclude=$confdir/exclude
38 [ ! -f $exclude ] && printf "tmp\ncore\n" > $exclude
39
40 if [ -z "$computer" ]; then
41         echo "Usage: $0 COMPUTER"
42         exit 1
43 fi
44
45 # Die more or less gracefully (at least notify user)
46 die() {
47         echo `date`": Something nasty happened."
48         rm $LOCKFILE
49         exit 1
50 }
51
52 # Trap C-c and kill
53 trap die SIGINT SIGTERM
54
55 # Don't start if we're already running
56 if [ -e $LOCKFILE ]; then
57         echo `date`": $LOCKFILE exists for pid `cat $LOCKFILE`, exiting."
58         echo `date`": $LOCKFILE exists for pid `cat $LOCKFILE`, exiting." >&2
59         exit 1
60 fi;
61 touch $LOCKFILE
62 echo $$ > $LOCKFILE
63
64 echo `date`": Backup run starting" >&2
65
66 umask 027
67
68
69 backup()
70 {
71         echo -n `date` >&2
72         printf " $computer: $computer:$filesystem $backuplevel backup\n" >&2
73
74         SNARFILE="${storagedir}/${computer}/${sfilesystem}/.incremental.snar"
75         incrementalsnar="/root/.backup/${sfilesystem}.snar"
76         if [ "$backuplevel" = "daglig" ]
77         then
78                 # If incremental backup, we need to copy the incremental status to $computer.
79                 # If it does not exist, whine a bit and then run date-based instead.
80                 if [ -s "$SNARFILE" ]; then
81                         if ! scp $SNARFILE root@$computer:$incrementalsnar; then
82                                 echo `date`" $computer: Could not copy .incremental.snar to $computer"
83                                 die
84                         fi
85                         lastcmd="--listed-incremental=$incrementalsnar --no-check-device"
86                 else
87                         echo `date`" $computer: Missing incremental.snar for $filesystem, doing date-based backup instead until next full backup" >&2
88                         incrementalsnar=""
89                         lastd=`cat ../.date`
90                         lastcmd="--newer='$lastd'"
91                 fi
92         else
93                 lastcmd="--listed-incremental=$incrementalsnar"
94         fi
95
96         # We try to run tar on the remote computer
97         #    c create archive
98         #    C change to directory first
99         #    . where to start taring (see C)
100         #    $lastcmd only files newer than this
101         #    --one-file-system don't traverse file systems
102         #    --use-compress-program compress it using gzip or pigz
103         #    --exclude-from file to get exclusion pattern from
104         #    Pipe the stuff over ssh to ourselves, run pee to cat the contents to a
105         #    file and build a file list, respectivly.  
106         TARFILE=$DATE.tmp
107         TARCMD="ssh root@$computer \"nice -n 19 ionice -c3 tar --one-file-system --use-compress-program $compressor -cf - -C $filesystem . $lastcmd \
108                 --exclude-from=/root/.backup/exclude\" | pee \"cat > $TARFILE\" \"tar tzvf -\""
109         echo `date`" $computer: Running $TARCMD" >&2
110         eval $TARCMD > $DATE.idx
111
112         if [ $? -eq 0 ] && [ -s $TARFILE ]; then
113                 # File is >0 in size and neither cat or tar tzvf failed; we assume it worked.
114
115                 if ! scp root@$computer:$incrementalsnar $SNARFILE.tmp; then
116                         echo `date`" $computer: Could not copy .incremental.snar from $computer"
117                         die
118                 fi
119
120                 # Move tar file in place
121                 mv $TARFILE $DATE.tgz
122                 mv $SNARFILE.tmp $SNARFILE
123
124                 # Update timestamp
125                 echo $DATEs > ../.date && touch -t $DATE ../.date
126
127                 # Make a sorted file list as well
128                 sort -k6 < $DATE.idx > $DATE.sdx
129
130                 # Fix permissions
131                 chmod 600 *tgz                      #only for us
132                 chmod 644 *sdx *idx 2>/dev/null     #everyone can read
133
134                 # Let the remote computer know that we ran a successful backup (for nagios)
135                 ssh root@$computer touch $filesystem/.lastbackup
136         else
137                 # Something wrong happened.
138                 rm $TARFILE
139                 echo `date`" $computer: $TARFILE empty. $backuplevel backup of $computer:$filesystem failed and deleted"
140                 die
141         fi
142 }
143
144 # Check that the target filesystem is mounted (actually check that it's not
145 # the root filesystem)
146 if [ ! -d "$storagedir/$computer" ]; then
147         echo `date`" $computer: Target filesystem ($storagedir/$computer) does not exist. Aborting"
148         die
149 fi
150 rootfilesystem=`df -P /`
151 targetfilesystem=`df -P "$storagedir/$computer"`
152 if [ "$rootfilesystem" == "$targetfilesystem" ]; then
153         echo `date`" $computer: Target filesystem ($storagedir/$computer) was mounted on /. Aborting"
154         die
155 fi
156
157 echo `date`" $computer: Backing up $computer" >&2
158
159 # Try to SSH to the computer without entering a password.
160 if ! `ssh -n -o NumberOfPasswordPrompts=0 root@$computer /bin/true`; then
161         echo `date`" $computer: Could not use passwordless SSH."
162         die
163 fi
164
165 # Check if pigz is available
166 if ssh -n root@$computer "pigz -V 2>/dev/null"; then
167         compressor=pigz
168 else
169         echo `date`" $computer: pigz missing; falling back to gzip."
170         compressor=gzip
171 fi
172
173 # Check dump bit in fstab
174 filesystems=`ssh -n root@$computer "cat /etc/fstab" \
175         | grep -v nfs \
176         | grep -v "^#" \
177         | grep -v "^$" \
178         | awk '{ if ( $(NF-1) != "0" ) print $2}' `
179
180 # Clean up our dir at this client
181 if ! ssh root@$computer "rm -r /root/.backup ; mkdir -m 700 /root/.backup"; then
182         echo `date`" $computer: Could not create backup staging area at $computer:/root/.backup"
183         die
184 fi
185
186 # Try to copy $exclude to $computer
187 if ! scp $exclude root@$computer:/root/.backup/exclude > /dev/null; then
188         echo `date`" $computer: Could not copy exclude.txt to $computer"
189         die
190 fi
191
192 # Try to copy preeexec and postexec if they exist
193 if [ -f $confdir/preexec.$computer ]; then
194         if ! scp $confdir/preexec.$computer  root@$computer:/root/.backup/preexec >&2; then
195                 echo `date`" $computer: Could not copy preexec.$computer to $computer:/root/.backup/preexec"
196                 die
197         fi
198 fi
199 if [ -f $confdir/postexec.$computer ]; then
200         if ! scp $confdir/postexec.$computer root@$computer:/root/.backup/postexec >&2; then
201                 echo `date`" $computer: Could not copy postexec.$computer to $computer:/root/.backup/postexec"
202                 die
203         fi
204 fi
205
206 # Try to run preexec if it exists
207 if ! ssh root@$computer "[ ! -f /root/.backup/preexec ] || /bin/bash -x /root/.backup/preexec" >&2; then
208         echo `date`" $computer: Could not run $computer:/root/.backup/preexec"
209         die
210 fi
211
212 for filesystem in $filesystems
213 do
214         # Remove / and $ (for Windows) for path names
215         sfilesystem=`echo $filesystem | tr '\/\$' '__'`
216
217         # Prepare storage area
218         mkdir -m 755 -p $storagedir/$computer/$sfilesystem/full 2>/dev/null
219         mkdir -m 755 -p $storagedir/$computer/$sfilesystem/daglig 2>/dev/null
220
221         # Default backuplevel
222         backuplevel=daglig
223
224         if [ ! -f $storagedir/$computer/$sfilesystem/.date ]
225         then
226                 # Take the first full backup of this filesystem on this computer
227                 backuplevel=full
228                 echo $DATEs > $storagedir/$computer/$sfilesystem/.date
229         fi
230
231         # Check if we want a full backup
232         if [ -f $confdir/fastfullbackupdag.$computer.$sfilesystem ]; then
233                 fullbackup_min_for_this_machine=$daysbetweenfullforfixed
234                 if [ "$DAY_OF_MONTH" = "`cat $confdir/fastfullbackupdag.$computer.$sfilesystem`" ]; then
235                         backuplevel=full
236                 fi
237         elif [ -f $confdir/fastfullbackupdag.$computer ]; then
238                 fullbackup_min_for_this_machine=$daysbetweenfullforfixed
239                 if [ "$DAY_OF_MONTH" = "`cat $confdir/fastfullbackupdag.$computer`" ]; then
240                         backuplevel=full
241                 fi
242         else
243                 fullbackup_min_for_this_machine=$daysbetweenfull 
244         fi
245
246         if [ -z "`find $storagedir/$computer/$sfilesystem/full/ -name \*tgz -mtime -$fullbackup_min_for_this_machine`" ]; then
247                 backuplevel=full
248         fi
249
250         # We want to be here
251         cd $storagedir/$computer/$sfilesystem/$backuplevel || die
252
253         # Perform the actual backup
254         backup
255
256         # Check if this box has a custom number of full backups
257         if [ -f $confdir/maksfulle.$computer ] ; then
258                 mf=$((`cat $confdir/maksfulle.$computer`+1))
259         else
260                 mf=$(($maxnumfull+1))
261         fi
262
263         # Delete old full backups
264         for full in `ls -1t $storagedir/$computer/$sfilesystem/full/*tgz | tail -n +$mf`
265         do
266                 prefix=`echo $full | sed "s/\.[^.]*$//"`
267                 echo `date`": $computer:$filesystem Deleting full backup $prefix" >&2
268                 rm $prefix*
269         done
270
271         # Delete incremental backups older than the oldest full backup
272         oldf=`ls -t1 $storagedir/$computer/$sfilesystem/full/*tgz | tail -1`
273         find \
274                 $storagedir/$computer/$sfilesystem/daglig \
275                 -type f \
276                 \! -newer $oldf \
277                 -printf "`date`: $computer: Deleting old incremental backup: %p\n" \
278                 -exec rm {} \; >&2
279 done
280
281 # Try to run postexec if it exist
282 if ! ssh root@$computer "[ ! -f /root/.backup/postexec ] || /bin/bash -x /root/.backup/postexec" >&2; then
283         echo `date`" $computer: Could not run $computer:/root/.backup/postexec"
284         die
285 fi
286
287 # Remove lockfile
288 rm $LOCKFILE